#!/usr/bin/env python
# @author Miroslav Bodis 2014
# miroslavbodis.com

import RPi.GPIO as GPIO
from time import sleep
import pygame, sys, time, random
from pygame.locals import *

pygame.init()
pygame.key.set_repeat(100, 100)
gameArea = pygame.display.set_mode((300, 300))

#print GPIO.VERSION
#exit()

GPIO.setmode(GPIO.  BOARD)

#GPIO.setup(7, GPIO.OUT)  dead
#GPIO.output(7, 1)        dead
#GPIO.setup(29, GPIO.OUT) dead
#GPIO.output(29, 1)       dead

#LED
GPIO.setup(11, GPIO.OUT)
GPIO.output(11, 1)
GPIO.setup(12, GPIO.OUT)
GPIO.output(12, 1)

#MOTOR-1 (jaws)
GPIO.setup(13, GPIO.OUT)
GPIO.output(13, 1)
GPIO.setup(15, GPIO.OUT)
GPIO.output(15, 1)

#MOTOR-2 (upper joint)
GPIO.setup(16, GPIO.OUT)
GPIO.output(16, 1)
GPIO.setup(18, GPIO.OUT)
GPIO.output(18, 1)

#MOTOR-3 (middle joint)
GPIO.setup(22, GPIO.OUT)
GPIO.output(22, 1)
GPIO.setup(31, GPIO.OUT)
GPIO.output(31, 1)

#MOTOR-4 (bottom joint)
GPIO.setup(32, GPIO.OUT)
GPIO.output(32, 1)
GPIO.setup(33, GPIO.OUT)
GPIO.output(33, 1)

#MOTOR-5 (base right left)
GPIO.setup(35, GPIO.OUT)
GPIO.output(35, 1)
GPIO.setup(36, GPIO.OUT)
GPIO.output(36, 1)


run = True
lock = [0,0,0,0,0,0]
lockChr = ['','','','','','']

## on key down event toggle relay ##
def keyDownLocker(key, char_A, GPIO_A, char_B, GPIO_B, index):
    if key == ord(char_A):
        if lock[index] == 0:
            GPIO.output(GPIO_A, 0)
            lock[index] = 1
            lockChr[index] = char_A
    if key == ord(char_B):
        if lock[index] == 0:
            GPIO.output(GPIO_B, 0)
            lock[index] = 1
            lockChr[index] = char_B


## on key up event toggle relay ##
def keyUpLocker(key, char_A, GPIO_A, char_B, GPIO_B, index):
    if key == ord(char_A):
        if lock[index] == 1 and lockChr[index] == char_A:
            GPIO.output(GPIO_A, 1)
            lock[index] = 0
    if key == ord(char_B) and lockChr[index] == char_B:
        if lock[index] == 1:
            GPIO.output(GPIO_B, 1)
            lock[index] = 0


## print help
def printHelp():
    print "# # # # # #"
    print "CONTROLS:"
    print " "
    print "a - toggle LED"
    print "w/s jaws controll (M1)"
    print "e/d first upper joint (M2)"
    print "r/f second middle joint (M3)"
    print "t/g bottom joint (M4)"
    print "y/h base left/right (M5)"
    print "# # # # # #"


printHelp()
try:
    while run:
        for event in pygame.event.get():
            
            if event.type == KEYDOWN:
                if event.key == 27:
                    run = False
                    GPIO.cleanup()
                if event.key == ord('q') or event.key == ord('a'):    
                    keyDownLocker(event.key, 'q', 11, 'a', 12, 0)
                if event.key == ord('w') or event.key == ord('s'):    
                    keyDownLocker(event.key, 'w', 13, 's', 15, 1)
                if event.key == ord('e') or event.key == ord('d'):    
                    keyDownLocker(event.key, 'e', 16, 'd', 18, 2)
                if event.key == ord('r') or event.key == ord('f'):    
                    keyDownLocker(event.key, 'r', 22, 'f', 31, 3)
                if event.key == ord('t') or event.key == ord('g'):    
                    keyDownLocker(event.key, 't', 32, 'g', 33, 4)
                if event.key == ord('y') or event.key == ord('h'):    
                    keyDownLocker(event.key, 'y', 35, 'h', 36, 5)                
            elif event.type == KEYUP:
                if event.key == ord('q') or event.key == ord('a'):
                    keyUpLocker(event.key, 'q', 11, 'a', 12, 0)
                if event.key == ord('w') or event.key == ord('s'):
                    keyUpLocker(event.key, 'w', 13, 's', 15, 1)
                if event.key == ord('e') or event.key == ord('d'):
                    keyUpLocker(event.key, 'e', 16, 'd', 18, 2)
                if event.key == ord('r') or event.key == ord('f'):
                    keyUpLocker(event.key, 'r', 22, 'f', 31, 3)
                if event.key == ord('t') or event.key == ord('g'):
                    keyUpLocker(event.key, 't', 32, 'g', 33, 4)
                if event.key == ord('y') or event.key == ord('h'):
                    keyUpLocker(event.key, 'y', 35, 'h', 36, 5)                
                    

except KeyboardInterrupt:    
    GPIO.cleanup()    

